import React, { FunctionComponent } from "react"
import {IonRadioGroup, IonRadio, IonLabel, IonItem, IonRow} from "@ionic/react"

const ConsentRadio: FunctionComponent<{
  commsConsent: string,
  setCommsConsent: Function,
  enabled: boolean
}> = ({children, commsConsent, setCommsConsent, enabled}) => {

  return (
  <IonRadioGroup value={commsConsent} onIonChange={e => {
    setCommsConsent(e.detail.value)
  }}>
    <IonRow>
      <IonItem>
        <IonRadio color="primary" value="yes" style={{marginRight: '1em'}} disabled={!enabled}/>
        <IonLabel >Yes I consent</IonLabel>
      </IonItem>
      <IonItem>
        <IonRadio color="primary" value="no" style={{marginRight: '1em'}} disabled={!enabled}/>
        <IonLabel >No I do not consent</IonLabel>
      </IonItem>
    </IonRow>
  </IonRadioGroup>
  )
}

export default ConsentRadio