import {
  IonButton,
} from '@ionic/react'
import React, { FunctionComponent, useContext } from "react"
import UserContext from '../context/UserContext'
import LoginStatus from '../components/LoginStatus'
import "./LoginBlock.css";
import { setDevUser } from '../js/dbapi.js'
//import * as Cookies from "js-cookie"
const Cookies = require('js-cookie')

const LoginBlock: FunctionComponent = () => {

  //console.log('Cookies.get()', Cookies.get())
  //console.log('document.cookie.split(";")', document.cookie.split(";"))

  const { setUsername, username } = useContext(UserContext)
  const logout: Function = async() => {
    Cookies.remove('SSO_DECIDE', { path: '/', domain: '.decide.staging.ceh.ac.uk'})
    Cookies.remove('SSO_DECIDE', { path: '/', domain: '.decide.ceh.ac.uk'})
    await setDevUser('')
    setUsername('')
  }

  const loginFn: Function = async () => {
    window.location.assign(`${process.env.REACT_APP_DBAPI_URL}login.html`)
  }

  return (<>
    <div style={{padding: '0.5em'}}>
      <LoginStatus />
      <IonButton className={username ? 'loginHide' : 'loginShow'} color="primary" onClick={(e) => loginFn()} >Login</IonButton>
      <IonButton className={username ? 'logoutShow' : 'logoutHide'} color="primary" onClick={(e) => logout()} >Logout</IonButton>
    </div>
  </>)
};
export default LoginBlock;