import ReactGA from 'react-ga'

const gaEnabled = !process.env.REACT_APP_GA_DISABLED

const ReactGAProxy = {
  initialize: function (...args) {
    if (gaEnabled) {
      ReactGA.initialize(...args)
    }
  },
  event: function (...args) {
    if (gaEnabled) {
      ReactGA.event(...args)
    }
  },
  set: function (...args) {
    if (gaEnabled) {
      ReactGA.set(...args)
    }
  },
  pageview: function (...args) {
    if (gaEnabled) {
      ReactGA.pageview(...args)
    }
  }
}

export default ReactGAProxy
