import React, { FunctionComponent } from 'react'
import { Circle } from 'react-leaflet'

interface ScoreCircleProps {
  map: any,
  radius: number,
  scoreImageUrl: string
}
const ScoreCircle: FunctionComponent<ScoreCircleProps> = ({map, radius, scoreImageUrl}) => {
  if (scoreImageUrl && scoreImageUrl!=='fetch') {
    const centre = map.getCenter()
    return <Circle 
      center={{lat: centre.lat, lng: centre.lng}}
      fillOpacity={0}
      radius={radius}
    />
  } else {
    return null
  }
}

export default ScoreCircle