import { IonToggle, IonList, IonItem, IonLabel, IonItemDivider, IonRange, IonRadioGroup, IonRadio, IonCard, IonCardContent } from '@ionic/react'
import React, { useContext } from 'react'
import { Link } from 'react-router-dom'
import './ScoreMapOpts.css'
import AppContext from '../context/AppContext'
import ScoreContext from '../context/ScoreContext'
//import Notice from './Notice'

const ScoreMapOpts: React.FC = () => {

  const { setScoreImageUrl } = useContext(ScoreContext)
  //const { showDecideScoreLayer,  setShowDecideScoreLayer} = useContext(AppContext)
  const { opacityDecideScoreLayer,  setOpacityDecideScoreLayer} = useContext(AppContext)
  //const { scaleDecideScoreLayer,  setScaleDecideScoreLayer} = useContext(AppContext)
  const { thresholdDecideScoreLayer,  setThresholdDecideScoreLayer} = useContext(AppContext)
  //const { radiusDecideScore,  setRadiusDecideScore, radiusMin, radiusMax} = useContext(AppContext)
  const { showRowAccess,  setShowRowAccess} = useContext(AppContext)
  const { showPointAccess,  setShowPointAccess} = useContext(AppContext)
  const { showGreenspaceAccess,  setShowGreenspaceAccess} = useContext(AppContext)
  const { showOpenAccess,  setShowOpenAccess} = useContext(AppContext)
  const { showNtAccess,  setShowNtAccess} = useContext(AppContext)
  const { showLondonAccess,  setShowLondonAccess} = useContext(AppContext)
  const { scoreTaxa, setScoreTaxa} = useContext(AppContext)

  const { prowGeojson, setProwGeojson} = useContext(ScoreContext)
  const { accesspointGeojson, setAccesspointGeojson} = useContext(ScoreContext)
  const { greenspaceGeojson, setGreenspaceGeojson} = useContext(ScoreContext)
  const { accesslandGeojson, setAccesslandGeojson} = useContext(ScoreContext)
  const { ntGeojson, setNtGeojson} = useContext(ScoreContext)
  const { londonGeojson, setLondonGeojson} = useContext(ScoreContext)
  
  //const { setScoreColour, scoreColour} = useContext(AppContext)

  // function limitRad() {
  //   if (isNaN(radiusDecideScore)) {
  //     setRadiusDecideScore(radiusMin)
  //   } else if (radiusDecideScore < radiusMin) {
  //     setRadiusDecideScore(radiusMin)
  //   } else if (radiusDecideScore > radiusMax) {
  //     setRadiusDecideScore(radiusMax)
  //   }
  // }

  //console.log('scoreTaxa', scoreTaxa)

  // function taxaChanged(taxon: string, include: boolean) {
  //   if (scoreTaxa.includes(taxon) && !include) {
  //     setScoreTaxa(scoreTaxa.filter(t => t !== taxon))
  //   } else if (!scoreTaxa.includes(taxon) && include) {
  //     setScoreTaxa([...scoreTaxa.map(t => t), taxon])
  //   }
  // }

  function taxaChanged(taxon: string) {
    setScoreTaxa([taxon])
    setScoreImageUrl('fetch')
  }

  function thresholdChange(threshold: any) {
    setThresholdDecideScoreLayer(threshold)
    setScoreImageUrl('fetch')
  }

  // function localChanged(local: boolean) {
  //   setScaleDecideScoreLayer(local)
  //   setScoreImageUrl('fetch')
  // }

  // function colourChanged(colour: string) {
  //   setScoreColour(colour)
  //   setScoreImageUrl('fetch')
  // }

  return (<>
    {/* <Notice text={`
      For more information on the DECIDE score and the map tool:
      `} colour="light" link="/info/decide_score" linkText="further info" /> */}

    <IonCard color='light'>
      <IonCardContent>
        Remember - keeping safe and legal when recording is <Link to="/info/user_agreement">your responsibility</Link>.
        For more information on the DECIDE score and the map tool: <Link to="/info/decide_score">further info</Link>
      </IonCardContent>
    </IonCard>

    <IonList>
      <IonItemDivider color="secondary" >Species groups</IonItemDivider>
      <IonRadioGroup value={scoreTaxa[0]} onIonChange={e => taxaChanged(e.detail.value)}>
        <IonItem lines='none'>
          <IonLabel>Butterflies</IonLabel>
          <IonRadio color="primary" value="butterfly" />
        </IonItem>
        <IonItem lines='none'>
          <IonLabel>Day-flying moths</IonLabel>
          <IonRadio color="primary" value="moth" />
        </IonItem>
      </IonRadioGroup>
      <IonItemDivider color="secondary">DECIDE score layer</IonItemDivider>
      {/* <IonItem lines='none'>
        <IonLabel >Search radius:</IonLabel>
        <IonInput type="number" 
          onBlur={() => limitRad()}
          min={`${radiusMin}`} 
          max={`${radiusMax}`} 
          step="100" 
          value={radiusDecideScore} 
          placeholder="Enter radius" 
          onIonChange={e => setRadiusDecideScore(parseInt(e.detail.value!, 10))}>
        </IonInput>
      </IonItem> */}
      {/* <IonItem lines='none'>
        <IonLabel>Layer visibility: {showDecideScoreLayer ? 'shown' : 'hidden'}</IonLabel>
        <IonToggle color="primary" checked={showDecideScoreLayer} onIonChange={e => setShowDecideScoreLayer(e.detail.checked)} />
      </IonItem> */}
      <IonItem lines='none'>
        <IonLabel >Opacity:</IonLabel>
        <IonRange className='opacitySlider' min={0} max={1} step={0.1} value={opacityDecideScoreLayer} onIonChange={e => setOpacityDecideScoreLayer(e.detail.value)} />
      </IonItem>
      {/* <IonItem lines='none'>
        <IonLabel>Local scaling: {scaleDecideScoreLayer ? 'on' : 'off'}</IonLabel>
        <IonToggle color="primary" checked={scaleDecideScoreLayer} onIonChange={e => localChanged(e.detail.checked)} />
      </IonItem> */}
      <IonItem lines='none'>
        <IonLabel >Threshold:</IonLabel>
        <IonRange className='opacitySlider' snaps={true} min={0} max={0.9} step={0.1} value={thresholdDecideScoreLayer} debounce={500} onIonChange={e => thresholdChange(e.detail.value)}>
          <IonLabel slot="end">{Math.round(thresholdDecideScoreLayer * 10)/10}</IonLabel>
        </IonRange>
      </IonItem>

      {/* <IonRadioGroup value={scoreColour} onIonChange={e => colourChanged(e.detail.value)}>
        <IonItem lines='none'>
          <IonLabel>Color - yellow to red</IonLabel>
          <IonRadio color="primary" value="yellow_red" />
        </IonItem>
        <IonItem lines='none'>
          <IonLabel>Color - cividis (grey to yellow)</IonLabel>
          <IonRadio color="primary" value="cividis" />
        </IonItem>
        <IonItem lines='none'>
          <IonLabel>Color - truncated viridis</IonLabel>
          <IonRadio color="primary" value="viridis_truncated" />
        </IonItem>
        <IonItem lines='none'>
          <IonLabel>Color - reds</IonLabel>
          <IonRadio color="primary" value="reds" />
          <IonLabel>Color - yellow to red</IonLabel>
          <IonRadio color="primary" value="yellow_red" />
        </IonItem>
        <IonItem lines='none'>
          <IonLabel>Color - purple to yellow</IonLabel>
          <IonRadio color="primary" value="viridis" />
        </IonItem>
        <IonItem lines='none'>
          <IonLabel>Colour - pink to green</IonLabel>
          <IonRadio color="primary" value="rev_terrain" />
        </IonItem>
        <IonItem lines='none'>
          <IonLabel>Colour - blue to red</IonLabel>
          <IonRadio color="primary" value="blue_orange_red" />
        </IonItem>
      </IonRadioGroup> */}

      <IonItemDivider color="secondary">Access layers</IonItemDivider>
      <IonItem lines='none'>
        <IonLabel>Rights of Way: {showRowAccess ? 'shown' : 'hidden'}</IonLabel>
        <IonToggle color="primary" checked={showRowAccess} onIonChange={e => {
          setShowRowAccess(e.detail.checked)
          if (e.detail.checked && !prowGeojson) {
            setProwGeojson("fetch")
          }
        }} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>Access points: {showPointAccess ? 'shown' : 'hidden'}</IonLabel>
        <IonToggle color="primary" checked={showPointAccess} onIonChange={e => {
          setShowPointAccess(e.detail.checked)
          if (e.detail.checked && !accesspointGeojson) {
            setAccesspointGeojson("fetch")
          }
        }} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>Greenspace: {showGreenspaceAccess ? 'shown' : 'hidden'}</IonLabel>
        <IonToggle color="primary" checked={showGreenspaceAccess} onIonChange={e => {
          setShowGreenspaceAccess(e.detail.checked)
          if (e.detail.checked && !greenspaceGeojson) {
            setGreenspaceGeojson("fetch")
          }
        }} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>Open access (limted availability): {showOpenAccess ? 'shown' : 'hidden'}</IonLabel>
        <IonToggle color="primary" checked={showOpenAccess} onIonChange={e => {
          setShowOpenAccess(e.detail.checked)
          if (e.detail.checked && !accesslandGeojson) {
            setAccesslandGeojson("fetch")
          }
        }} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>National Trust: {showNtAccess ? 'shown' : 'hidden'}</IonLabel>
        <IonToggle color="primary" checked={showNtAccess} onIonChange={e => {
          setShowNtAccess(e.detail.checked)
          if (e.detail.checked && !ntGeojson) {
            setNtGeojson("fetch")
          }
        }} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>London access: {showLondonAccess ? 'shown' : 'hidden'}</IonLabel>
        <IonToggle color="primary" checked={showLondonAccess} onIonChange={e => {
          setShowLondonAccess(e.detail.checked)
          if (e.detail.checked && !londonGeojson) {
            setLondonGeojson("fetch")
          }
        }} />
      </IonItem>

      {/* <IonItemDivider>For demo - dynamic layer generation</IonItemDivider>
      <IonItem lines='none'>
        <IonLabel>Cistus Forester (<i>Adscita geryon</i>)</IonLabel>
        <IonToggle color="primary" checked={scoreTaxa.includes("Adscita_geryon")} onIonChange={e => taxaChanged('Adscita_geryon',e.detail.checked)} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>Green Forester (<i>Adscita statices</i>)</IonLabel>
        <IonToggle color="primary" checked={scoreTaxa.includes("Adscita_statices")} onIonChange={e => taxaChanged('Adscita_statices',e.detail.checked)} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>Broad-bordered White Underwing (<i>Anarta melanopa</i>)</IonLabel>
        <IonToggle color="primary" checked={scoreTaxa.includes("Anarta_melanopa")} onIonChange={e => taxaChanged('Anarta_melanopa',e.detail.checked)} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>Beautiful Yellow Underwing (<i>Anarta myrtilli</i>)</IonLabel>
        <IonToggle color="primary" checked={scoreTaxa.includes("Anarta_myrtilli")} onIonChange={e => taxaChanged('Anarta_myrtilli',e.detail.checked)} />
      </IonItem>
      <IonItem lines='none'>
        <IonLabel>Orange Underwing (<i>Archiearis parthenias</i>)</IonLabel>
        <IonToggle color="primary" checked={scoreTaxa.includes("Archiearis_parthenias")} onIonChange={e => taxaChanged('Archiearis_parthenias',e.detail.checked)} />
      </IonItem> */}


    </IonList>
  </>)
}
export default ScoreMapOpts;