import { 
  IonLabel,
  IonSelect,
  IonSelectOption
} from '@ionic/react'
import React, { useContext, } from 'react'
import { Timeline } from 'react-twitter-widgets'
import UserContext from '../context/UserContext'
import socialMediaFeeds from '../resources/socialMediaFeeds.json'
import ls from 'local-storage'

const options = socialMediaFeeds
  .filter(smf => smf.type === 'twitter')
  .map(smf => <IonSelectOption key={smf.id} value={smf.id}>{smf.name}</IonSelectOption>)

const SocialMediaFeed: React.FC<{}> = () => {

  const { mediaFeed, setMediaFeed } = useContext(UserContext)

  const smSelected = (sm: string) => {
    setMediaFeed(sm)
    ls('smfeed', sm)
  }

  return (
    <>
    <IonLabel style={{marginLeft: '1em'}} color="primary">Partner Twitter feed...</IonLabel>
    <IonSelect value={mediaFeed} okText="Okay" cancelText="Dismiss" onIonChange={e => smSelected(e.detail.value)}>
      {options}
    </IonSelect>
    <Timeline
      dataSource={{
        sourceType: 'profile',
        screenName: mediaFeed
      }}
      options={{
        height: '1000'
      }}
    />
    </>
  )
}

export default SocialMediaFeed