import React from 'react'
import { TileLayer, LayersControl  } from 'react-leaflet'
//import './LeafletMap.css'

const StandardLayers = () => {
  return (<>
  <LayersControl position="topright">
      <LayersControl.BaseLayer checked name="Standard OpenStreetMap">
        <TileLayer
          url='https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png'
          attribution='&copy; <a href=&quot;http://osm.org/copyright&quot;>OpenStreetMap</a> contributors. Use of data is subject to <a style="cursor: pointer" onclick="termsAndConditions()">terms and conditions</a>.'
        />
      </LayersControl.BaseLayer>
      <LayersControl.BaseLayer name="Simple map">
        <TileLayer
          url='https://stamen-tiles-{s}.a.ssl.fastly.net/toner-lite/{z}/{x}/{y}{r}.png'
          attribution='Map tiles by <a href="http://stamen.com">Stamen Design</a>, <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a> &mdash; Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
        />
      </LayersControl.BaseLayer>
  </LayersControl>
  </>)
}
export default StandardLayers