import React, { FunctionComponent, useEffect, useContext } from 'react'
import { useIonViewDidEnter } from '@ionic/react'
import { ZoomControl, ScaleControl } from 'react-leaflet'
import MapButton from './MapButton'
import Version from './Version'
import AppContext from '../context/AppContext'
interface InvalidateSizeI {
  map: any
}
const InvalidateSize: FunctionComponent<InvalidateSizeI>  = ({map}) => {
  // Might not need this nere if in useEffect
  useIonViewDidEnter(() => {
    //https://ionicframework.com/docs/react/lifecycle
    //console.log('ionViewDidEnter - invalidateSize')
    map.invalidateSize()
  })
  return null
}

interface StandardMapControlsI {
  map: any
}
const StandardMapControls: FunctionComponent<StandardMapControlsI> = ({map}) => {

  const { surveyLink } = useContext(AppContext)

  useEffect(() => {
    map.invalidateSize()
  })
  return (<>
      <InvalidateSize map={map}/>
      <ZoomControl  position='topright'/>
      <MapButton map={map} position='bottomright' title='Feedback' id='decide-map-feedback-button'
                    onClick={() => {
                      // window.location.href = `${surveyLink}`
                      window.open(surveyLink, '_blank')
                    }}>
                    Feedback on v<Version/>
                  </MapButton>
      <ScaleControl position='bottomright' />
  </>)
}
export default StandardMapControls