import React from 'react';

interface App {
  tool: string;
  setTool: any;
  path: string;
  setPath: any;
  showOpts: boolean;
  setShowOpts: any;
  showRowAccess: boolean;
  setShowRowAccess: any;
  showPointAccess: boolean;
  setShowPointAccess: any;
  showGreenspaceAccess: boolean;
  setShowGreenspaceAccess: any;
  showOpenAccess: boolean;
  setShowOpenAccess: any;
  showNtAccess: boolean;
  setShowNtAccess: any;
  showLondonAccess: boolean;
  setShowLondonAccess: any;
  showDecideScoreLayer: boolean;
  setShowDecideScoreLayer: any;
  opacityDecideScoreLayer: number;
  setOpacityDecideScoreLayer: any;
  scaleDecideScoreLayer: boolean;
  setScaleDecideScoreLayer: any;
  thresholdDecideScoreLayer: number;
  setThresholdDecideScoreLayer: any;
  radiusDecideScore: number;
  setRadiusDecideScore: any;
  scoreTaxa: Array<string>,
  setScoreTaxa: any;
  scoreColour: string,
  setScoreColour: any;
  radiusMin: number;
  radiusMax: number;
  surveyLink: string;
}

const AppContext = React.createContext<App>({
  tool: '',
  setTool: null,
  path: '',
  setPath: null,
  showOpts: false,
  setShowOpts: null,
  showRowAccess: true,
  setShowRowAccess: null,
  showPointAccess: true,
  setShowPointAccess: null,
  showGreenspaceAccess: true,
  setShowGreenspaceAccess: null,
  showOpenAccess: true,
  setShowOpenAccess: null,
  showNtAccess: false,
  setShowNtAccess: null,
  showLondonAccess: false,
  setShowLondonAccess: null,
  showDecideScoreLayer: true,
  setShowDecideScoreLayer: null,
  opacityDecideScoreLayer: 0,
  setOpacityDecideScoreLayer: null,
  scaleDecideScoreLayer: true,
  setScaleDecideScoreLayer: null,
  thresholdDecideScoreLayer: 0,
  setThresholdDecideScoreLayer: null,
  radiusDecideScore: 0,
  setRadiusDecideScore: null,
  scoreTaxa: [],
  setScoreTaxa: null,
  scoreColour: '',
  setScoreColour: null,
  radiusMin: 0,
  radiusMax: 0,
  surveyLink: ''
});

export default AppContext;