import React, { useContext, useEffect, useState } from "react";
import {
  IonHeader, 
  IonToolbar, 
  IonTitle, 
  IonContent, 
  IonPage, 
  IonButtons, 
  IonMenuButton,
  IonItem,
  IonLabel,
  IonToggle,
  IonItemDivider,
  IonInput,
  IonButton,
} from '@ionic/react';
import { getUsername, getUserDetails, insertUser, updateUser } from '../js/dbapi.js'
import LoginStatus from '../components/LoginStatus'
import "./User.css"
import UserContext from '../context/UserContext'
import Notice from '../components/Notice'
import Track from '../components/Track'
// import ConsentRadio from '../components/ConsentRadio'

const User: React.FC = () => {

  const { setUsername, username } = useContext(UserContext)
  const { setFirstname, firstname } = useContext(UserContext)
  const [ firstnameForm, setFirstnameForm ] = useState('')
  const { setFullname, fullname } = useContext(UserContext)
  const [ fullnameForm, setFullnameForm ] = useState('')
  const { setUseData, useData } = useContext(UserContext)
  const [ useDataForm, setUseDataForm ] = useState(false)
  const { setInterestMoths, interestMoths } = useContext(UserContext)
  const [ interestMothsForm, setInterestMothsForm ] = useState(false)
  const { setInterestButterflies, interestButterflies } = useContext(UserContext)
  const [ interestButterfliesForm, setInterestButterfliesForm ] = useState(false)
  const { setInterestGrasshoppers, interestGrasshoppers } = useContext(UserContext)
  const [ interestGrasshoppersForm, setInterestGrasshoppersForm ] = useState(false)
  // const { setGeneralConsent, generalConsent } = useContext(UserContext)
  // const [ generalConsentForm, setGeneralConsentForm ] = useState(false)
  // const { setCommsConsent, commsConsent } = useContext(UserContext)
  // const [ commsConsentForm, setCommsConsentForm ] = useState('')
  const { setOtherPlatformConsent, otherPlatformConsent } = useContext(UserContext)
  const [ otherPlatformConsentForm, setOtherPlatformConsentForm ] = useState(false)
  const { setIspotUsername, ispotUsername } = useContext(UserContext)
  const [ ispotUsernameForm, setIspotUsernameForm ] = useState('')
  const { setIrecordUsername, irecordUsername } = useContext(UserContext)
  const [ irecordUsernameForm, setIrecordUsernameForm ] = useState('')

  useEffect(() => {
    (async () => { 
      const u = await getUsername()
      if (u.username !== username) {
        //console.log('Username and proxy.username not equal')
        //console.log('u.username', u.username)
        //console.log('username', username)
        setUsername(u.username)
        let data = await getUserDetails()
        //console.log('getUserDetails', data)
        // If the data is set to empty object, then this user does not
        // yet exist in the DB, so insert an entry for them.
        if (Object.entries(data).length === 0) {
          data = await insertUser()
          console.log('insertUser', data)
        }
        setFirstname(data.firstname ? data.firstname : '')
        setFirstnameForm(data.firstname ? data.firstname: '')
        setFullname(data.fullname ? data.fullname : '')
        setFullnameForm(data.fullname ? data.fullname : '')
        setUseData(data.usedata ? true : false)
        setUseDataForm(data.usedata ? true : false)
        setInterestMoths(data.moths ? true : false)
        setInterestMothsForm(data.moths ? true : false)
        setInterestButterflies(data.butterflies ? true : false)
        setInterestButterfliesForm(data.butterflies ? true : false)
        setInterestGrasshoppers(data.grasshoppers ? true : false)
        setInterestGrasshoppersForm(data.grasshoppers ? true : false)
        // setGeneralConsent(data.generalConsent ? true : false)
        // setGeneralConsentForm(data.generalConsent ? true : false)
        // setCommsConsent(data.commsConsent ? data.commsConsent : '')
        // setCommsConsentForm(data.commsConsent ? data.commsConsent : '')
        setOtherPlatformConsent(data.otherPlatformConsent ? true : false)
        setOtherPlatformConsentForm(data.otherPlatformConsent ? true : false)
        setIspotUsername(data.ispotUsername ? data.ispotUsername : '')
        setIspotUsernameForm(data.ispotUsername ? data.ispotUsername : '')
        setIrecordUsername(data.irecordUsername ? data.irecordUsername : '')
        setIrecordUsernameForm(data.irecordUsername ? data.irecordUsername : '')
      } else if (username === '') {
        setFirstname('')
        setFirstnameForm('')
        setFullnameForm('')
        setUseData(false)
        setUseDataForm(false)
        setInterestMoths(false)
        setInterestMothsForm(false)
        setInterestButterflies(false)
        setInterestButterfliesForm(false)
        setInterestGrasshoppers(false)
        setInterestGrasshoppersForm(false)
        // setGeneralConsent(false)
        // setGeneralConsentForm(false)
        // setCommsConsent('')
        // setCommsConsentForm('')
        setOtherPlatformConsent(false)
        setOtherPlatformConsentForm(false)
        setIspotUsername('')
        setIspotUsernameForm('')
        setIrecordUsername('')
        setIrecordUsernameForm('')
      }
    })()
  }, [
    username,
    setUsername,
    setFirstname,
    setFullname,
    setUseData,
    setInterestMoths,
    setInterestButterflies,
    setInterestGrasshoppers,
    // setGeneralConsent,
    // setCommsConsent,
    setOtherPlatformConsent,
    setIspotUsername,
    setIrecordUsername
  ])

  const dataHasChanged:Function = () => {
    let changed = false
    if (username) {
      if (firstnameForm !== firstname) changed = true
      if (fullnameForm !== fullname) changed = true
      if (useDataForm !== useData) changed = true
      if (interestMothsForm !== interestMoths) changed = true
      if (interestButterfliesForm !== interestButterflies) changed = true
      if (interestGrasshoppersForm !== interestGrasshoppers) changed = true
      // if (generalConsentForm !== generalConsent) changed = true
      // if (commsConsentForm !== commsConsent) changed = true
      if (otherPlatformConsentForm !== otherPlatformConsent) changed = true
      if (ispotUsernameForm !== ispotUsername) changed = true
      if (irecordUsernameForm !== irecordUsername) changed = true
    }
    // Ensure that general consent and comms option set
    //console.log('generalConsentForm', generalConsentForm)
    //console.log('commsConsentForm', commsConsentForm)

    // if(!generalConsentForm || commsConsentForm === '') {
    //   changed = false
    // }
    return changed
  }

  const updateUserFn:Function = async () => {
    const body = {
      firstname: firstnameForm,
      fullname: fullnameForm,
      usedata: useDataForm ? 1 : 0,
      moths: interestMothsForm ? 1 : 0,
      butterflies: interestButterfliesForm ? 1 : 0,
      grasshoppers: interestGrasshoppersForm ? 1 : 0,
      // generalConsent: generalConsentForm ? 1 : 0,
      // commsConsent: commsConsentForm,
      otherPlatformConsent: otherPlatformConsentForm ? 1 : 0,
      ispotUsername: ispotUsernameForm,
      irecordUsername: irecordUsernameForm,
    }
    await updateUser(body)
    setFirstname(firstnameForm)
    setFullname(fullnameForm)
    setUseData(useDataForm)
    setInterestButterflies(interestButterfliesForm)
    setInterestMoths(interestMothsForm)
    setInterestGrasshoppers(interestGrasshoppersForm)
    // setGeneralConsent(generalConsentForm)
    // setCommsConsent(commsConsentForm)
    setOtherPlatformConsent(otherPlatformConsentForm)
    setIspotUsername(ispotUsernameForm)
    setIrecordUsername(irecordUsernameForm)
  }

  return (
    <IonPage id="login-page">
      <Track/>
      <IonContent>
        <IonHeader>
          <IonToolbar>
            <IonButtons slot="start">
              <IonMenuButton />
            </IonButtons>
            <IonTitle>Your DECIDE account</IonTitle> 
          </IonToolbar>
        </IonHeader>
        <Notice text={`
          For more information on personal information in the DECIDE app:
          `} colour="light" link="/info/user_agreement" linkText="further info" />
        <IonItem lines="full"> 
          <LoginStatus/>
        </IonItem>

        {/* <div style={{display: username && !generalConsent ? '' : 'none'}}>
          <IonItem lines='none'>
            <IonLabel>General consent</IonLabel>
          </IonItem>
          <IonItem lines="none" >
            <div style={{minWidth: '4em'}}>
              <IonToggle disabled={!username} checked={generalConsentForm} onIonChange={e => setGeneralConsentForm(e.detail.checked)}/>
            </div>
            <p style={{fontSize: '0.9em'}}>
              I consent to my information about the use of the Tool being used by researchers 
              in the DECIDE project to evaluate and improve the outputs of the project, and 
              to assess the process of co-development of the Tool. 
            </p>
          </IonItem>
          <Notice text={`
            If you do not provide consent, some features of the app may not be available to you.
            `} colour="warning" />
          <div style={{padding: '0 1em', borderBottom: '1px solid lightgrey'}}>
            <p style={{fontSize: '0.9em'}}>
              Information collected can include specific
              ways in which you interact with the Tool, responses to recommendations made 
              through the Tool and other interventions included during the co-development 
              of the Tool. All results will be anonymised so that users are not individually 
              identifiable. Anonymised comments (i.e., without personal or identifying 
              information) may be used in publicly available documents including scientific papers.
              All your data will be kept confidentially, and access will be restricted to the 
              evaluation team. Anonymised comments may be used in scientific publications from 
              the DECIDE project team to assess the process of evaluation of this tool by 
              volunteers. Parts of this study requiring ethical approval have had this granted 
              by The University of York Environment Department Research Ethics Committee.
            </p>
          </div>
       
          <IonItem lines='none'>
            <IonLabel>Communications consent (select an option)</IonLabel>
          </IonItem>
          
          <ConsentRadio commsConsent={commsConsentForm} setCommsConsent={setCommsConsentForm} enabled={generalConsentForm}/>
          <div style={{padding: '0 1em', borderBottom: '1px solid lightgrey'}}>
            <p style={{fontSize: '0.9em'}}>
              If you consent, you will receive occasional news, updates and communication about the DECIDE project. 
              We will not use your contact details for purposes outside of the DECIDE 
              project. You can opt out at any time by 
              contacting decide@ceh.ac.uk.
            </p>
          </div>
        </div> */}
        
        {/* <div style={{display: username && generalConsent ? '' : 'none'}}> */}
        <div style={{display: username ? '' : 'none'}}>
          <IonItemDivider color="secondary">Personal details</IonItemDivider>
          <IonItem>
            <IonLabel position="stacked">Full name</IonLabel>
            <IonInput disabled={!username} value={fullnameForm} placeholder="Enter your full name" onIonChange={e => setFullnameForm(e.detail.value!)}></IonInput>
          </IonItem>
          <IonItem>
            <IonLabel position="stacked">First name</IonLabel>
            <IonInput disabled={!username} value={firstnameForm} placeholder="Enter the name you like to be called by" onIonChange={e => setFirstnameForm(e.detail.value!)}></IonInput>
          </IonItem>
          <IonItem lines="full" style={{display: 'none'}}>
            <IonLabel position="stacked" >Track use data</IonLabel>
            <IonToggle disabled={!username} checked={useDataForm} onIonChange={e => setUseDataForm(e.detail.checked)} />
          </IonItem>
          <IonItemDivider color="secondary">Taxonomic interests</IonItemDivider>
          <IonItem lines="full">
            <IonLabel position="stacked" >Butterflies</IonLabel>
            <IonToggle disabled={!username} checked={interestButterfliesForm} onIonChange={e => setInterestButterfliesForm(e.detail.checked)}/>
          </IonItem>
          <IonItem lines="full">
            <IonLabel position="stacked" >Moths</IonLabel>
            <IonToggle disabled={!username} checked={interestMothsForm} onIonChange={e => setInterestMothsForm(e.detail.checked)}/>
          </IonItem>
          <IonItem lines="full">
            <IonLabel position="stacked" >Grasshoppers and Crickets</IonLabel>
            <IonToggle disabled={!username} checked={interestGrasshoppersForm} onIonChange={e => setInterestGrasshoppersForm(e.detail.checked)}/>
          </IonItem>
          <IonItemDivider color="secondary">Links to recording platforms</IonItemDivider>
          <IonItem lines="none" style={{display: otherPlatformConsent ? 'none' : ''}}>
            {/* <IonButton disabled={!username} onClick={e => givePlatformConsent()}>Give consent</IonButton> */}
            <div style={{minWidth: '4em'}}>
              <IonToggle disabled={!username} checked={otherPlatformConsentForm} onIonChange={e => setOtherPlatformConsentForm(e.detail.checked)}/>
            </div>
            <p style={{fontSize: '0.9em'}}>
              I consent to my use of the DECIDE Tool when I am logged in to be associated 
              with species records that I have submitted to iRecord and/or iSpot. 
            </p>
          </IonItem>
          <div style={{padding: '0 1em', borderBottom: '1px solid lightgrey'}}>
            <p style={{fontSize: '0.9em', display: otherPlatformConsent ? '' : 'none'}}>
              Thank you for providing consent for us to associate your use of the 
              DECIDE Tool, when you are logged in,
              with species records you have submitted to iRecord and/or iSpot.
            </p>
            <p style={{fontSize: '0.9em'}} >
              Why do we ask for this? This is very valuable to help us evaluate the DECIDE Tool 
              and to improve it for you and for others. Records in these databases are publically 
              available but we are asking your permission to associate these with your use of 
              the DECIDE Tool, both now and through any future changes that will be introduced to the Tool. 
              We will not present the results in a way that allows you to be individually identified. 
            </p>
            <p style={{fontSize: '0.9em'}} >
              You can withdraw your consent for this at any time by contacting decide@ceh.ac.uk and at 
              that point your data will be removed from analyses apart from those already in the public domain.
            </p>
          </div>
          <IonItem>
            <IonLabel position="stacked">iRecord username (if you have one, optional)</IonLabel>
            <IonInput disabled={!username || !otherPlatformConsentForm} value={irecordUsernameForm} placeholder="Enter your iRecord username if you have" onIonChange={e => setIrecordUsernameForm(e.detail.value!)}></IonInput>
          </IonItem>
          <IonItem>
            <IonLabel position="stacked">iSpot username (if you have one, optional)</IonLabel>
            <IonInput disabled={!username || !otherPlatformConsentForm} value={ispotUsernameForm} placeholder="Enter your iSpot username" onIonChange={e => setIspotUsernameForm(e.detail.value!)}></IonInput>
          </IonItem>
        </div>
        <div style={{display: username ? '' : 'none'}}>
          <IonButton disabled={!dataHasChanged()} onClick={e => updateUserFn()}>Save changes</IonButton>
        </div>
      </IonContent>
    </IonPage>
  );
}

export default User