# ASSIST E-Planner image server
The image server provides services written in R made assessible through a REST interface provided by [R Plumber](https://www.rplumber.io/).

The image server is bundled in the same project as the ASSIST E-Planner app.

## Running in development
One way to run in development is to use the bundled docker file to build an image and serve it with Docker, e.g:
`docker run --rm --name imageapi -p 5000:80 imageapi`.

Another way, very useful for development and debugging, is to serve from R Studio by sourcing the Main.R file.

## Endpoints for opportunity map images
The image server takes a post request which includes an area of interest defined in GeoJson format. There are four endpoints for this as follows:

- `/imageapi/birds`
- `/imageapi/pollinators`
- `/imageapi/woodland`
- `/imageapi/runoff`

Upon getting a request for an image the code builds the approprate image by merging relevant 10 km tiles and then cutting to the area of interest. It then removes any outlying values from the area of interst (setting all values above the 95th percentile to the value of the 95th percentile and all values below the 5th percentile to the value of the 5th percentile) before scaling the values to values between 0 and 1.

Ideally this would be done on a selection of eight intermediate layers (the selection depends on the opportunity layer being generated) before being summed in a prescribed fashion. But performance problems meant that we have, instead, created four pre-summed opportunity layers and the do the scaling on these. Note though that the facility to do it this way still exists in the code.

Once the opportunity map layer has been generated, it is colourised converted to a PNG image which is streamed back as the response to the request.

## Endpoint for importance metrics
A fifth endpoint, `/imageapi/priorities`, takes an area of interest and by overlaying on four low resolution images describing the relative importance of different parts of the country for each of the four opportunity layers, it returns a json structure containing metrics to show those relative importances.