# Source main code
source("processing.R")

#* @filter cors
cors <- function(req, res) {
    res$setHeader("Access-Control-Allow-Origin", "*")

    if (req$REQUEST_METHOD == "OPTIONS") {
      res$setHeader("Access-Control-Allow-Methods","*")
      res$setHeader("Access-Control-Allow-Headers", req$HTTP_ACCESS_CONTROL_REQUEST_HEADERS)
      res$status <- 200 
      return(list())
    } else {
      plumber::forward()
    }
}

#* @get /score/test
#* @serializer contentType list(type='image/png')
get_generate <- function(){
  
  # Area overlapping edge of test area
  #lat=51.7421
  #lon=-1.5184
  #rad=5000
  
  # Wallingford
  lat=51.602436
  lon=-1.110557
  rad=5000
  
  ret = generateImage(lat, lon, rad)
  return(ret)
}

#* @get /score/point-rad
#* @serializer contentType list(type='image/png')
get_generate <- function(lat, lon, rad){
  
  ret = generateImage(as.numeric(lat), as.numeric(lon), as.numeric(rad))
  return(ret)
}

#* @post /score/point-rad
#* @serializer contentType list(type='image/png')
post_generate <- function(req){
  
  ret = generateImagePost(req$postBody)
  
  # Wallingford
  #body = '{"lat": "51.602436","lon": "-1.110557", "rad": "5000", "names": ["Adscita_geryon","Adscita_statices","Anarta_melanopa","Anarta_myrtilli","Archiearis_parthenias"]}'
  #body = '{"lat": "51.602436","lon": "-1.110557", "rad": "5000", "names": ["Anarta_melanopa","Anarta_myrtilli","Archiearis_parthenias"]}'
  #ret = generateImagePost(body)
  
  return(ret)
}

#* @post /score/point-rad-json
post_generate_json <- function(req){

  # This was created to test the heatmap idea and not currently used
  
  ret = generateRiskJsonByNames(req$postBody)
  
  # Wallingford
  #body = '{"lat": "51.602436","lon": "-1.110557", "rad": "5000", "names": ["Adscita_geryon","Adscita_statices","Anarta_melanopa","Anarta_myrtilli","Archiearis_parthenias"]}'
  #ret = generateRiskJsonByNames(body)
  
  return(ret)
}

#* @get /score/point-rad-pre-test
#* @serializer contentType list(type='image/png')
get_pre_generated_image <- function(){
  
  #http://localhost:4000/score/point-rad-pre?rad=5000&lat=52.501175722709455&lon=-1.4996337890625002&name=moth&colour=blue_orange_red&threshold=0&local=true
  
  ret = getPreGeneratedImage(52.50, -1.49, 5000, 'moth', TRUE, 0, 'viridis_truncated')
  return(ret)
}

#* @get /score/point-rad-pre
#* @serializer contentType list(type='image/png')
get_pre_generated_image <- function(lat, lon, rad, name, local, threshold, colour){

  #http://localhost:4000/score/point-rad-pre?rad=5000&lat=52.501175722709455&lon=-1.4996337890625002&name=moth&colour=blue_orange_red&threshold=0&local=true

  ret = getPreGeneratedImage(as.numeric(lat), as.numeric(lon), as.numeric(rad), name, local=='true', as.numeric(threshold), colour)
  return(ret)
}

#* @get /score/testg
get_accessgjson <- function(){
  
  # Area overlapping edge of test area
  lat=51.7421
  lon=-1.5184
  rad=5000
  type='greenspace' #prow, greenpsace, accesspoint, accessland
  
  # Wallingford
  lat=51.602436
  lon=-1.110557
  rad=5000
  
  # No data
  #lat=52.501175722709455
  #lon=-1.4996337890625002
  #rad=5000
  #type='prow'
  

  ret = accessGeoJson(lat, lon, rad, type)
  return(ret)
}

#* @get /score/gjson
#* @serializer json
get_accessgjson <- function(lat, lon, rad, type){
  
  ret = accessGeoJson(as.numeric(lat), as.numeric(lon), as.numeric(rad), type)
  print(ret)
  return(ret)
}

